diff -uwr sourceold/scripts/AudibleSoundDefinitionClass.cpp source/scripts/AudibleSoundDefinitionClass.cpp
--- sourceold/scripts/AudibleSoundDefinitionClass.cpp	2011-10-11 23:04:16.190429600 +0800
+++ source/scripts/AudibleSoundDefinitionClass.cpp	2012-04-17 17:06:17.560546800 +0800
@@ -28,30 +28,30 @@
 AudibleSoundDefinitionClass::AudibleSoundDefinitionClass() : m_Priority(0.5), m_Volume(1), m_VolumeRandomizer(0), m_Pan(0.5), m_LoopCount(1), m_VirtualChannel(0), m_DropoffRadius(40), m_MaxVolRadius(20), m_Is3DSound(true), m_Type(1), m_StartOffset(0), m_PitchFactor(1), m_PitchFactorRandomizer(0), m_LogicalType(0), m_LogicalNotifDelay(2.0), m_LogicalDropoffRadius(-1.0), m_CreateLogicalSound(false), m_SphereColor(0,0.75,0.75)
 {
 #ifdef PARAM_EDITING_ON
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_FILENAME,m_Filename,"Filename");
-	INT_EDITABLE_PARAM(CNCModeSettingsDef,m_Filename,0,100);
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_FLOAT,m_DropoffRadius,"Drop-off Radius");
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_FLOAT,m_MaxVolRadius,"Max-Vol Radius");
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_BOOL,m_Is3DSound,"Is 3D Sound");
-	INT_EDITABLE_PARAM(CNCModeSettingsDef,m_LoopCount,0,1000000);
-	FLOAT_EDITABLE_PARAM(CNCModeSettingsDef,m_Volume,0,1.0);
-	FLOAT_UNITS_PARAM(CNCModeSettingsDef,m_VolumeRandomizer,0,1.0,"Volume Random (+/-)");
-	FLOAT_EDITABLE_PARAM(CNCModeSettingsDef,m_Pan,0,1.0);
-	FLOAT_EDITABLE_PARAM(CNCModeSettingsDef,m_Priority,0,1.0);
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_FILENAME,m_Filename,"Filename");
+	INT_EDITABLE_PARAM(AudibleSoundDefinitionClass,m_VirtualChannel,0,100);
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_FLOAT,m_DropoffRadius,"Drop-off Radius");
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_FLOAT,m_MaxVolRadius,"Max-Vol Radius");
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_BOOL,m_Is3DSound,"Is 3D Sound");
+	INT_EDITABLE_PARAM(AudibleSoundDefinitionClass,m_LoopCount,0,1000000);
+	FLOAT_EDITABLE_PARAM(AudibleSoundDefinitionClass,m_Volume,0,1.0);
+	FLOAT_UNITS_PARAM(AudibleSoundDefinitionClass,m_VolumeRandomizer,0,1.0,"Volume Random (+/-)");
+	FLOAT_EDITABLE_PARAM(AudibleSoundDefinitionClass,m_Pan,0,1.0);
+	FLOAT_EDITABLE_PARAM(AudibleSoundDefinitionClass,m_Priority,0,1.0);
 	EnumParameterClass * type = new EnumParameterClass(&m_Type);		
 	type->Set_Name ("m_Type");
 	type->Add_Value("Sound Effect",1);
 	type->Add_Value("Music",0);
 	type->Add_Value("Dialog",2);
 	type->Add_Value("Cinematic",3);
-	GENERIC_EDITABLE_PARAM( CNCModeSettingsDef, type);
-	FLOAT_EDITABLE_PARAM(CNCModeSettingsDef,m_StartOffset,0,1.0);
-	FLOAT_EDITABLE_PARAM(CNCModeSettingsDef,m_PitchFactor,0,1.0);
-	FLOAT_UNITS_PARAM(CNCModeSettingsDef,m_PitchFactorRandomizer,0,1.0,"Pitch Factor Random (+/-)");
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_STRING,m_DisplayText,"Display Text");
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_BOOL,m_CreateLogicalSound,"Create Logical Sound");
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_FLOAT,m_LogicalDropoffRadius,"Logical Drop-off Radius");
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_FLOAT,m_LogicalNotifDelay,"Logical Notif Delay");
+	GENERIC_EDITABLE_PARAM( AudibleSoundDefinitionClass, type);
+	FLOAT_EDITABLE_PARAM(AudibleSoundDefinitionClass,m_StartOffset,0,1.0);
+	FLOAT_EDITABLE_PARAM(AudibleSoundDefinitionClass,m_PitchFactor,0,1.0);
+	FLOAT_UNITS_PARAM(AudibleSoundDefinitionClass,m_PitchFactorRandomizer,0,1.0,"Pitch Factor Random (+/-)");
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_STRING,m_DisplayText,"Display Text");
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_BOOL,m_CreateLogicalSound,"Create Logical Sound");
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_FLOAT,m_LogicalDropoffRadius,"Logical Drop-off Radius");
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_FLOAT,m_LogicalNotifDelay,"Logical Notif Delay");
 	EnumParameterClass * logical = new EnumParameterClass(&m_LogicalType);		
 	logical->Set_Name ("Logical Type");
 	logical->Add_Value("None",0);
@@ -69,8 +69,8 @@
 	logical->Add_Value("Designer07",12);
 	logical->Add_Value("Designer08",13);
 	logical->Add_Value("Designer09",14);
-	GENERIC_EDITABLE_PARAM( CNCModeSettingsDef, logical);
-	NAMED_EDITABLE_PARAM(CNCModeSettingsDef,ParameterClass::TYPE_COLOR,m_SphereColor,"Sphere Color");
+	GENERIC_EDITABLE_PARAM( AudibleSoundDefinitionClass, logical);
+	NAMED_EDITABLE_PARAM(AudibleSoundDefinitionClass,ParameterClass::TYPE_COLOR,m_SphereColor,"Sphere Color");
 #endif
 }
 
@@ -264,3 +264,15 @@
 	m_SphereColor = that.m_SphereColor;
 	return *this;
 }
+
+#ifdef DDBEDIT
+void AudibleSoundDefinitionClass::Dump(FileClass &file)
+{
+	for (int i = 0;i < this->Get_Parameter_Count();i++)
+	{
+		ParameterClass *param = this->Lock_Parameter(i);
+		param->Dump(file);
+		this->Unlock_Parameter(i);
+	}
+}
+#endif
diff -uwr sourceold/scripts/AudibleSoundDefinitionClass.h source/scripts/AudibleSoundDefinitionClass.h
--- sourceold/scripts/AudibleSoundDefinitionClass.h	2011-10-11 21:57:45.827148400 +0800
+++ source/scripts/AudibleSoundDefinitionClass.h	2012-05-06 16:37:04.987218700 +0800
@@ -26,27 +26,6 @@
 class AudibleSoundDefinitionClass :
 	public DefinitionClass
 {
-	DECLARE_EDITABLE(AudibleSoundDefinitionClass,DefinitionClass);
-	float m_Priority; // 001C
-	float m_Volume; // 0020
-	float m_VolumeRandomizer; // 0024
-	float m_Pan; // 0028
-	int m_LoopCount; // 002C
-	int m_VirtualChannel; // 0030
-	float m_DropoffRadius; // 0034
-	float m_MaxVolRadius; // 0038
-	bool m_Is3DSound; // 003C
-	StringClass m_Filename; // 0040
-	int m_Type; // 0044
-	StringClass m_DisplayText; // 0048
-	float m_StartOffset; // 004C
-	float m_PitchFactor; // 0050
-	float m_PitchFactorRandomizer; // 0054
-	int m_LogicalType; // 0058
-	float m_LogicalNotifDelay; // 005C
-	float m_LogicalDropoffRadius; // 0060
-	bool m_CreateLogicalSound; // 0064
-	Vector3 m_SphereColor; // 0068
 public:
 	virtual ~AudibleSoundDefinitionClass();
 	virtual const PersistFactoryClass& Get_Factory() const;
@@ -80,6 +59,31 @@
 	bool Save_Variables(ChunkSaveClass&);
 	bool Load_Variables(ChunkLoadClass&);
 	const AudibleSoundDefinitionClass &operator=(AudibleSoundDefinitionClass const &that);
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
+	DECLARE_EDITABLE(AudibleSoundDefinitionClass,DefinitionClass);
+private:
+	float m_Priority; // 001C
+	float m_Volume; // 0020
+	float m_VolumeRandomizer; // 0024
+	float m_Pan; // 0028
+	int m_LoopCount; // 002C
+	int m_VirtualChannel; // 0030
+	float m_DropoffRadius; // 0034
+	float m_MaxVolRadius; // 0038
+	bool m_Is3DSound; // 003C
+	StringClass m_Filename; // 0040
+	int m_Type; // 0044
+	StringClass m_DisplayText; // 0048
+	float m_StartOffset; // 004C
+	float m_PitchFactor; // 0050
+	float m_PitchFactorRandomizer; // 0054
+	int m_LogicalType; // 0058
+	float m_LogicalNotifDelay; // 005C
+	float m_LogicalDropoffRadius; // 0060
+	bool m_CreateLogicalSound; // 0064
+	Vector3 m_SphereColor; // 0068
 	friend class PresetDump;
 };
 
diff -uwr sourceold/scripts/BaseControllerClass.h source/scripts/BaseControllerClass.h
--- sourceold/scripts/BaseControllerClass.h	2011-10-11 21:57:41.484375000 +0800
+++ source/scripts/BaseControllerClass.h	2012-05-23 08:29:05.815429600 +0800
@@ -82,6 +82,7 @@
 	bool Can_Build_Air();
 	bool Can_Build_Ground();
 	bool Can_Build_Naval();
+	void Check_Prerequisites();
 
 	bool Is_Base_Powered() const
 	{
@@ -119,6 +120,10 @@
 	{
 		return RadarEnabled;
 	}
+	DynamicVectorClass<BuildingGameObj*> &Get_Building_List()
+	{
+		return BuildingList;
+	}
 }; // 072C
 
 #endif
\ No newline at end of file
diff -uwr sourceold/scripts/BaseGameObjDef.h source/scripts/BaseGameObjDef.h
--- sourceold/scripts/BaseGameObjDef.h	2011-10-11 21:57:37.723632800 +0800
+++ source/scripts/BaseGameObjDef.h	2012-05-06 16:37:05.002843700 +0800
@@ -18,6 +18,9 @@
 public:
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	friend class PresetDump;
 }; // 001C
 
diff -uwr sourceold/scripts/BeaconGameObj.h source/scripts/BeaconGameObj.h
--- sourceold/scripts/BeaconGameObj.h	2011-10-11 21:57:36.038085900 +0800
+++ source/scripts/BeaconGameObj.h	2012-05-23 11:12:36.067382800 +0800
@@ -47,7 +47,7 @@
 	virtual const PersistFactoryClass& Get_Factory() const;
 	virtual void Init();
 	void Init(const BeaconGameObjDef &);
-	const BeaconGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const BeaconGameObjDef & Get_Definition( void ) const ;
 	void Init_Beacon(const WeaponDefinitionClass* definition, SoldierGameObj* owner, const Vector3& position);
 	virtual bool Save(ChunkSaveClass& chunks);
 	virtual bool Load(ChunkLoadClass& chunks);
diff -uwr sourceold/scripts/BeaconGameObjDef.h source/scripts/BeaconGameObjDef.h
--- sourceold/scripts/BeaconGameObjDef.h	2012-01-13 08:30:18.359375000 +0800
+++ source/scripts/BeaconGameObjDef.h	2012-05-06 16:37:05.014562500 +0800
@@ -24,6 +24,9 @@
 	uint32 Get_Class_ID() const;
 	PersistClass* Create() const;
 	bool Is_Nuke() const {return IsNuke;}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( BeaconGameObjDef, SimpleGameObjDef );
 private:
 	float BroadcastToAllTime; // 00AC
diff -uwr sourceold/scripts/BuildingGameObj.h source/scripts/BuildingGameObj.h
--- sourceold/scripts/BuildingGameObj.h	2011-10-11 21:57:29.629882800 +0800
+++ source/scripts/BuildingGameObj.h	2012-04-14 04:09:47.160156200 +0800
@@ -84,6 +84,8 @@
 	virtual void								On_Damaged (void);
 	bool											Is_Destroyed (void) const { return IsDestroyed; }
 	void Set_Is_Destroyed(const bool _IsDestroyed) { IsDestroyed = _IsDestroyed; }
+	bool											Is_Spy_Disabled() const { return IsSpyDisabled; }
+	void Set_Is_Spy_Disabled(const bool _IsSpyDisabled) {IsSpyDisabled = _IsSpyDisabled; }
 	virtual	void								Import_Rare (BitStreamClass &packet);
 	virtual	void								Export_Rare (BitStreamClass &packet);
 	virtual	void								Export_Creation (BitStreamClass &packet);
@@ -111,6 +113,7 @@
 	bool											IsDestroyed;
 	Vector3										Position;
 	bool											IsPowerOn;
+	bool											IsSpyDisabled;
 	int											CurrentState;						// derived from the health and IsPowerOn
 	AudibleSoundClass *						CurrentAnnouncement;
 	SphereClass									AnnouncementSphere;
diff -uwr sourceold/scripts/BuildingGameObjDef.h source/scripts/BuildingGameObjDef.h
--- sourceold/scripts/BuildingGameObjDef.h	2011-10-11 21:57:27.790039000 +0800
+++ source/scripts/BuildingGameObjDef.h	2012-05-06 16:37:05.027257800 +0800
@@ -60,6 +60,9 @@
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
 	virtual const PersistFactoryClass &	Get_Factory( void ) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( BuildingGameObjDef, DamageableGameObjDef );
 	void										Set_Type (BuildingConstants::BuildingType type) { Type = type; }
 	BuildingConstants::BuildingType				Get_Type (void) const	{ return Type; }
diff -uwr sourceold/scripts/C4GameObj.h source/scripts/C4GameObj.h
--- sourceold/scripts/C4GameObj.h	2011-10-11 21:57:26.085937500 +0800
+++ source/scripts/C4GameObj.h	2012-05-23 11:12:52.194335900 +0800
@@ -40,7 +40,7 @@
 	~C4GameObj();
 	void Init();
 	void Init(const C4GameObjDef &);
-	const C4GameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const C4GameObjDef & Get_Definition( void ) const ;
 	void Init_C4(AmmoDefinitionClass const *ammoPreset, SoldierGameObj* owner, uint32 detonationMode, const Matrix3D& muzzle);
 	CollisionReactionType Collision_Occurred(const CollisionEventClass& collide);
 	bool Save(ChunkSaveClass &csave);
diff -uwr sourceold/scripts/C4GameObjDef.h source/scripts/C4GameObjDef.h
--- sourceold/scripts/C4GameObjDef.h	2011-10-11 21:57:24.221679600 +0800
+++ source/scripts/C4GameObjDef.h	2012-05-06 16:37:05.039953100 +0800
@@ -21,6 +21,9 @@
 	bool Load(ChunkLoadClass &cload);
 	uint32 Get_Class_ID() const;
 	PersistClass *Create() const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( C4GameObjDef, SimpleGameObjDef );
 private:
 	float ThrowVelocity;
diff -uwr sourceold/scripts/CinematicGameObj.h source/scripts/CinematicGameObj.h
--- sourceold/scripts/CinematicGameObj.h	2011-10-11 21:57:10.641601500 +0800
+++ source/scripts/CinematicGameObj.h	2012-05-23 11:12:59.759765600 +0800
@@ -25,7 +25,7 @@
 	void Init();
 	void Init(const CinematicGameObjDef &);
 	void Cinematic_Init();
-	const CinematicGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const CinematicGameObjDef & Get_Definition( void ) const ;
 	bool Save(ChunkSaveClass &csave);
 	bool Load(ChunkLoadClass &cload);
 	void On_Post_Load();
diff -uwr sourceold/scripts/CinematicGameObjDef.h source/scripts/CinematicGameObjDef.h
--- sourceold/scripts/CinematicGameObjDef.h	2011-10-11 21:57:08.957031200 +0800
+++ source/scripts/CinematicGameObjDef.h	2012-05-06 16:37:05.053625000 +0800
@@ -21,6 +21,10 @@
 	bool Load(ChunkLoadClass &cload);
 	uint32 Get_Class_ID() const;
 	PersistClass *Create() const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
 	DECLARE_EDITABLE( CinematicGameObjDef, ArmedGameObjDef );
 private:
 	int SoundDefID;
diff -uwr sourceold/scripts/ComCenterGameObj.h source/scripts/ComCenterGameObj.h
--- sourceold/scripts/ComCenterGameObj.h	2011-10-11 21:56:58.881835900 +0800
+++ source/scripts/ComCenterGameObj.h	2012-05-23 11:13:09.483398400 +0800
@@ -20,7 +20,7 @@
 	~ComCenterGameObj (void);
 	virtual	void					Init( void );
 	void								Init (const ComCenterGameObjDef & definition);
-	const ComCenterGameObjDef &	Get_Definition (void) const;
+	SCRIPTS_API const ComCenterGameObjDef &	Get_Definition (void) const;
 	ComCenterGameObj *				As_ComCenterGameObj (void)	{ return this; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/ComCenterGameObjDef.h source/scripts/ComCenterGameObjDef.h
--- sourceold/scripts/ComCenterGameObjDef.h	2011-10-11 21:56:57.004882800 +0800
+++ source/scripts/ComCenterGameObjDef.h	2012-05-06 16:37:05.070226600 +0800
@@ -22,6 +22,9 @@
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (ComCenterGameObjDef, BuildingGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/ConstructionYardGameObj.h source/scripts/ConstructionYardGameObj.h
--- sourceold/scripts/ConstructionYardGameObj.h	2011-10-11 21:56:47.152343700 +0800
+++ source/scripts/ConstructionYardGameObj.h	2012-05-23 11:13:18.676757800 +0800
@@ -22,7 +22,7 @@
 	~ConstructionYardGameObj (void);
 	virtual	void					Init( void );
 	void								Init (const ConstructionYardGameObjDef & definition);
-	const ConstructionYardGameObjDef &	Get_Definition (void) const;
+	SCRIPTS_API const ConstructionYardGameObjDef &	Get_Definition (void) const;
 	ConstructionYardGameObj *				As_ConstructionYardGameObj (void)	{ return this; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/ConstructionYardGameObjDef.h source/scripts/ConstructionYardGameObjDef.h
--- sourceold/scripts/ConstructionYardGameObjDef.h	2011-10-11 21:56:45.261718700 +0800
+++ source/scripts/ConstructionYardGameObjDef.h	2012-05-06 16:37:05.081945300 +0800
@@ -22,6 +22,9 @@
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (ConstructionYardGameObjDef, BuildingGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/DamageZoneGameObj.h source/scripts/DamageZoneGameObj.h
--- sourceold/scripts/DamageZoneGameObj.h	2011-10-11 21:56:28.727539000 +0800
+++ source/scripts/DamageZoneGameObj.h	2012-05-23 11:14:00.280273400 +0800
@@ -26,7 +26,7 @@
 	bool Load(ChunkLoadClass &cload);
 	void Init();
 	void Init(const DamageZoneGameObjDef &);
-	const DamageZoneGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const DamageZoneGameObjDef & Get_Definition( void ) const ;
 	void Think();
 	void Set_Bounding_Box(OBBoxClass &box) {BoundingBox = box;}
 	OBBoxClass &Get_Bounding_Box() {return BoundingBox;}
diff -uwr sourceold/scripts/DamageZoneGameObjDef.h source/scripts/DamageZoneGameObjDef.h
--- sourceold/scripts/DamageZoneGameObjDef.h	2011-10-11 21:56:26.795898400 +0800
+++ source/scripts/DamageZoneGameObjDef.h	2012-05-06 16:37:05.110265600 +0800
@@ -22,6 +22,9 @@
 	uint32 Get_Class_ID() const;
 	PersistClass *Create() const;
 	Vector3 &Get_Color() {return Color;}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE(DamageZoneGameObjDef, BaseGameObjDef);
 private:
 	float DamageRate;
diff -uwr sourceold/scripts/DamageableGameObj.h source/scripts/DamageableGameObj.h
--- sourceold/scripts/DamageableGameObj.h	2011-10-11 21:56:32.453125000 +0800
+++ source/scripts/DamageableGameObj.h	2012-05-23 11:24:09.008789000 +0800
@@ -37,10 +37,10 @@
 	virtual	DamageableGameObj	*As_DamageableGameObj( void )	{ return this; }
 	virtual int Get_Player_Type(void) const {return PlayerType;}
 	virtual void Set_Player_Type(int type);
-	bool		Is_Team_Player(void);
+	SCRIPTS_API bool		Is_Team_Player(void);
 	Vector3		Get_Team_Color(void);
-	bool		Is_Teammate(DamageableGameObj * p_obj);
-	bool		Is_Enemy(DamageableGameObj * p_obj);
+	SCRIPTS_API bool		Is_Teammate(DamageableGameObj * p_obj);
+	SCRIPTS_API bool		Is_Enemy(DamageableGameObj * p_obj);
 	virtual	void								Import_Occasional( BitStreamClass &packet );
 	virtual	void								Export_Occasional( BitStreamClass &packet );
 	bool Is_Damaged()
diff -uwr sourceold/scripts/DamageableGameObjDef.h source/scripts/DamageableGameObjDef.h
--- sourceold/scripts/DamageableGameObjDef.h	2011-10-11 21:56:30.630859300 +0800
+++ source/scripts/DamageableGameObjDef.h	2012-05-06 16:37:05.098546900 +0800
@@ -26,6 +26,9 @@
 	DamageableGameObjDef( void );
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( DamageableGameObjDef, ScriptableGameObjDef );
 	int											Get_Name_ID (void) const	{ return TranslatedNameID; }
 	int											Get_Encyclopedia_Type (void) const	{ return EncyclopediaType; }
diff -uwr sourceold/scripts/DecorationPhysDefClass.h source/scripts/DecorationPhysDefClass.h
--- sourceold/scripts/DecorationPhysDefClass.h	2011-10-11 21:56:12.504882800 +0800
+++ source/scripts/DecorationPhysDefClass.h	2012-05-06 16:37:05.122960900 +0800
@@ -26,6 +26,9 @@
 	virtual const PersistFactoryClass &	Get_Factory (void) const;
 	virtual bool								Save(ChunkSaveClass &csave);
 	virtual bool								Load(ChunkLoadClass &cload);
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE(DecorationPhysDefClass,DynamicPhysDefClass);
 protected:
 	friend class StaticPhysClass;
diff -uwr sourceold/scripts/Definition.h source/scripts/Definition.h
--- sourceold/scripts/Definition.h	2011-10-11 21:56:03.347656200 +0800
+++ source/scripts/Definition.h	2012-04-16 19:44:48.389648400 +0800
@@ -12,9 +12,9 @@
 #ifndef TT_INCLUDE_DEFINITION_H
 #define TT_INCLUDE_DEFINITION_H
 #include "Editable.h"
+class FileClass;
 class DefinitionClass : public EditableClass {
 public:
-	DECLARE_EDITABLE(DefinitionClass, EditableClass);
 	DefinitionClass (void);
 	virtual ~DefinitionClass (void);
 	virtual uint32						Get_Class_ID (void) const = 0;
@@ -30,6 +30,11 @@
 	void									Set_User_Data (uint32 data)	{ m_GenericUserData = data; }
 	bool									Is_Save_Enabled (void) const	{ return m_SaveEnabled; }
 	void									Enable_Save (bool onoff)		{ m_SaveEnabled = onoff; }
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
+	DECLARE_EDITABLE(DefinitionClass, EditableClass);
 protected:
 	int											m_DefinitionMgrLink; // 0008
 private:
Only in source/scripts: Doxyfile
diff -uwr sourceold/scripts/DynamicPhysClass.h source/scripts/DynamicPhysClass.h
--- sourceold/scripts/DynamicPhysClass.h	2011-10-11 21:55:09.958984300 +0800
+++ source/scripts/DynamicPhysClass.h	2012-04-14 04:09:47.578125000 +0800
@@ -26,12 +26,10 @@
 	virtual void								Set_Model(RenderObjClass * model);
 	void											Update_Visibility_Status(void);
 	virtual int									Get_Vis_Object_ID(void);
-#ifndef TTLE_EXPORTS
 	virtual bool								Is_Simulation_Disabled(void)				{ return _DisableDynamicPhysSimulation; }
 	virtual bool								Is_Rendering_Disabled(void)				{ return _DisableDynamicPhysRendering; }
 	static void									Disable_All_Simulation(bool onoff)		{ _DisableDynamicPhysSimulation = onoff; }
 	static void									Disable_All_Rendering(bool onoff)		{ _DisableDynamicPhysRendering = onoff; }
-#endif
 	virtual bool								Save (ChunkSaveClass &csave);
 	virtual bool								Load (ChunkLoadClass &cload);
 	virtual void								On_Post_Load(void);
@@ -41,10 +39,8 @@
 	int											VisNodeID; // 007C  007C  0098  0094
 	unsigned int								VisStatusLastUpdated; // 0080  0080  009C  0098
 private:
-#ifndef TTLE_EXPORTS
-	static REF_DECL2(_DisableDynamicPhysSimulation,bool);
-	static REF_DECL2(_DisableDynamicPhysRendering,bool);
-#endif
+	static bool _DisableDynamicPhysSimulation;
+	static bool _DisableDynamicPhysRendering;
 	DynamicPhysClass(const DynamicPhysClass &);
 	DynamicPhysClass & operator = (const DynamicPhysClass &);
 }; // 0084  0084  00A0  009C
diff -uwr sourceold/scripts/DynamicPhysDefClass.h source/scripts/DynamicPhysDefClass.h
--- sourceold/scripts/DynamicPhysDefClass.h	2011-10-11 21:54:51.746093700 +0800
+++ source/scripts/DynamicPhysDefClass.h	2012-05-06 16:37:05.135656200 +0800
@@ -24,6 +24,9 @@
 	virtual const char *						Get_Type_Name(void)			{ return "DynamicPhysDef"; }
 	virtual bool								Is_Type(const char *);
 	virtual bool								Is_Valid_Config (StringClass &message);
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE(DynamicPhysDefClass,PhysDefClass);
 protected:
 	friend class DynamicPhysClass;
diff -uwr sourceold/scripts/GameObjManager.h source/scripts/GameObjManager.h
--- sourceold/scripts/GameObjManager.h	2012-02-13 13:28:20.240632800 +0800
+++ source/scripts/GameObjManager.h	2012-05-23 11:29:01.416015600 +0800
@@ -28,6 +28,7 @@
 class BuildingGameObj;
 class C4GameObj;
 class BeaconGameObj;
+class ScriptZoneGameObj;
 
 class GameObjManager
 {
@@ -42,6 +43,7 @@
 	static SHADERS_API SList<BeaconGameObj> BeaconGameObjList;
 	static SHADERS_API SList<SoldierGameObj> SoldierGameObjList;
 	static SHADERS_API SList<VehicleGameObj> VehicleGameObjList;
+	static SHADERS_API SList<ScriptZoneGameObj> ScriptZoneGameObjList;
 #ifndef TTLE_EXPORTS
 	static REF_DECL2(CinematicFreezeActive, bool);
 #endif
@@ -52,7 +54,7 @@
 	static void Think();
 	static void Post_Think();
 	static PhysicalGameObj* Find_PhysicalGameObj(int);
-	static SmartGameObj* Find_SmartGameObj(int);
+	SCRIPTS_API static SmartGameObj* Find_SmartGameObj(int);
 	static void Init();
 	static void Shutdown();
 	static bool Save(ChunkSaveClass&);
diff -uwr sourceold/scripts/HarvesterClass.h source/scripts/HarvesterClass.h
--- sourceold/scripts/HarvesterClass.h	2011-10-11 21:52:33.959960900 +0800
+++ source/scripts/HarvesterClass.h	2012-04-27 22:33:07.907226500 +0800
@@ -98,6 +98,7 @@
    {
 	   return harvester;
    }
+   State Get_State() {return state;}
    void            Harvest_Tiberium       ();
    void            Play_Harvest_Animation (bool play);
    void            Think                  ();
Only in source/scripts: LoopedAnimationController.cpp
Only in source/scripts: LoopedAnimationController.h
diff -uwr sourceold/scripts/Matrix3D.cpp source/scripts/Matrix3D.cpp
--- sourceold/scripts/Matrix3D.cpp	2011-10-11 23:05:52.368164000 +0800
+++ source/scripts/Matrix3D.cpp	2012-04-23 13:05:44.549046900 +0800
@@ -48,6 +48,19 @@
 }
 
 
+int Matrix3D::Is_Orthogonal(void) const
+{
+	Vector3 x(Row[0].X,Row[0].Y,Row[0].Z);
+	Vector3 y(Row[1].X,Row[1].Y,Row[1].Z);
+	Vector3 z(Row[2].X,Row[2].Y,Row[2].Z);
+	if (Vector3::Dot_Product(x,y) > WWMATH_EPSILON) return 0;
+	if (Vector3::Dot_Product(y,z) > WWMATH_EPSILON) return 0;
+	if (Vector3::Dot_Product(z,x) > WWMATH_EPSILON) return 0;
+	if (WWMath::Fabs(x.Length2() - 1.0f) > WWMATH_EPSILON) return 0;
+	if (WWMath::Fabs(y.Length2() - 1.0f) > WWMATH_EPSILON) return 0;
+	if (WWMath::Fabs(z.Length2() - 1.0f) > WWMATH_EPSILON) return 0;
+	return 1;
+}
 
 void Matrix3D::Get_Orthogonal_Inverse (Matrix3D& inv) const
 {
diff -uwr sourceold/scripts/Matrix3D.h source/scripts/Matrix3D.h
--- sourceold/scripts/Matrix3D.h	2011-10-11 21:50:23.392578100 +0800
+++ source/scripts/Matrix3D.h	2012-04-23 13:05:44.507054700 +0800
@@ -502,6 +502,7 @@
 		Row[1][2] = (float)(s*tmp1 + c*tmp2);
 	}
 
+	int	Is_Orthogonal(void) const; 
    Vector3  applyTo      (const Vector3& vector) const;
    Vector3  getPosition  () const;
    Matrix3  getRotation  () const;
diff -uwr sourceold/scripts/MoveablePhysDefClass.h source/scripts/MoveablePhysDefClass.h
--- sourceold/scripts/MoveablePhysDefClass.h	2011-10-11 21:49:58.500976500 +0800
+++ source/scripts/MoveablePhysDefClass.h	2012-05-06 16:37:05.148351600 +0800
@@ -27,6 +27,9 @@
 	float											Get_Grav_Scale(void)			{ return GravScale; }
 	void											Set_Mass(float new_mass)	{ Mass = new_mass; }
 	void											Set_Grav_Scale(float new_g){ GravScale = new_g; }
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE(MoveablePhysDefClass,DynamicPhysDefClass);
 protected:
 	float				Mass;
Only in source/scripts: NavalFactoryGameObj.h
Only in source/scripts: NavalFactoryGameObjDef.h
diff -uwr sourceold/scripts/Parameter.h source/scripts/Parameter.h
--- sourceold/scripts/Parameter.h	2011-10-11 21:49:22.120117100 +0800
+++ source/scripts/Parameter.h	2012-04-16 23:58:26.740234300 +0800
@@ -14,6 +14,7 @@
 #include "Engine_String.h"
 #include "Engine_Vector.h"
 class DefParameterClass;
+class FileClass;
 class ParameterClass
 {
 public:
@@ -64,6 +65,9 @@
 	virtual const char *		Get_Units_Name (void) const;
 	virtual void				Set_Units_Name (const char *units_name);
 	virtual void				Copy_Value (const ParameterClass &src) { };
+#ifdef DDBEDIT
+	virtual void                Dump(FileClass &file) = 0;
+#endif
 	static ParameterClass *	Construct (ParameterClass::Type type, void *data, const char *param_name);
 private:
 	bool				IsModified;
diff -uwr sourceold/scripts/PhysDefClass.h source/scripts/PhysDefClass.h
--- sourceold/scripts/PhysDefClass.h	2011-10-11 21:49:10.120117100 +0800
+++ source/scripts/PhysDefClass.h	2012-05-06 16:37:05.173742200 +0800
@@ -100,6 +100,9 @@
 	virtual bool					Is_Valid_Config (StringClass &message);
 	const StringClass &			Get_Model_Name()					{ return ModelName; }
 	bool								Get_Is_Pre_Lit()					{ return IsPreLit; }
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE(PhysDefClass,DefinitionClass);
 protected:
 	StringClass						ModelName;
diff -uwr sourceold/scripts/PhysicalGameObj.h source/scripts/PhysicalGameObj.h
--- sourceold/scripts/PhysicalGameObj.h	2012-02-17 16:57:48.055664000 +0800
+++ source/scripts/PhysicalGameObj.h	2012-05-23 11:24:07.594726500 +0800
@@ -47,7 +47,7 @@
 	void					Set_Position(const Vector3 & pos);
 	float					Get_Facing(void) const;
 	inline RenderObjClass	*	Peek_Model( void ) { return Peek_Physical_Object()->Peek_Model(); }
-	AnimControlClass*	Get_Anim_Control( void );
+	SCRIPTS_API AnimControlClass*	Get_Anim_Control( void );
 	void					Set_Anim_Control( AnimControlClass * anim_control );
 	virtual	void	Set_Animation( const char *animation_name, bool looping = true, float frame_offset = 0.0f );
 	virtual	void	Set_Animation_Frame ( const char *animation_name, int frame );
@@ -62,7 +62,7 @@
 	virtual	bool	Takes_Explosion_Damage( void )						{ return true; }
 	int	Get_Type()	const		{ return Get_Definition().Type; }
 	virtual	void	Post_Think();
-	void		Set_Collision_Group( int group );
+	void		SCRIPTS_API Set_Collision_Group( int group );
 	Collision_Group_Type Get_Collision_Group() const { return PhysObj->Get_Collision_Group(); }
 	virtual ExpirationReactionType	Object_Expired( PhysClass * observed_obj ) { Set_Delete_Pending(); return 1; }
 	virtual	PhysicalGameObj		*As_PhysicalGameObj( void )	{ return this; }
@@ -109,7 +109,7 @@
 	bool				Is_HUD_Pokable_Indicator_Enabled( void )		{ return HUDPokableIndicatorEnabled; } 
 	virtual void		Set_Player_Type(int type);
 	virtual void	Object_Shattered_Something(PhysClass * observed_obj, PhysClass * shattered_obj, int surface_type);
-	void                Clear_Animation() {if (AnimControl) {AnimControl->Set_Mode(ANIM_MODE_STOP,0);ClearAnimation = true;Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);}}
+	void                Clear_Animation() {if (AnimControl) {AnimControl->Set_Animation((const char*)NULL, 0, 0);AnimControl->Set_Mode(ANIM_MODE_STOP,0);ClearAnimation = true;Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);}}
 protected:
 	ActiveConversationClass *ActiveConversation;
 private:
diff -uwr sourceold/scripts/PhysicalGameObjDef.h source/scripts/PhysicalGameObjDef.h
--- sourceold/scripts/PhysicalGameObjDef.h	2011-10-11 21:49:01.494140600 +0800
+++ source/scripts/PhysicalGameObjDef.h	2012-05-06 16:37:05.186437500 +0800
@@ -21,6 +21,9 @@
 	virtual bool								Is_Valid_Config (StringClass &message);
 	int		Get_Phys_Def_ID( void ) const	{ return PhysDefID; }
 	int		Get_Orator_Type( void ) const	{ return OratorType; }
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( PhysicalGameObjDef, DamageableGameObjDef );
 protected:
 	int											Type;					
